<?php
namespace AustraliaPost\Extensions\Business\API\Wrapper;

/**
 * To construct the get items price json
 */
class Price_Request{

	private $fromPostcode;
	private $fromCountry;
	private $toPostcode;
	private $toCountry;
	private $items = array();

	/**
	 * @return mixed
	 */
	public function getFromPostcode() {
		return $this->fromPostcode;
	}

	public function getFromCountry() {
		return $this->fromCountry;
	}

	/**
	 * @param mixed $fromPostcode
	 *
	 * @return Price_Request
	 */
	public function setFromPostcode( $fromPostcode ) {
		$this->fromPostcode = $fromPostcode;
		return $this;
	}

	/**
	 * @param mixed $fromCountry
	 *
	 * @return Price_Request
	 */
	public function setFromCountry( $fromCountry ) {
		$this->fromCountry = $fromCountry;
		return $this;
	}

	/**
	 * @return mixed
	 */
	public function getToPostcode() {
		return $this->toPostcode;
	}

	/**
	 * @return mixed
	 */
	public function getToCountry() {
		return $this->toCountry;
	}

	/**
	 * @param mixed $toPostcode
	 *
	 * @return Price_Request
	 */
	public function setToPostcode( $toPostcode ) {
		$this->toPostcode = $toPostcode;
		return $this;
	}

	/**
	 * @param mixed $toCountry
	 *
	 * @return Price_Request
	 */
	public function setToCountry( $toCountry ) {
		$this->toCountry = $toCountry;
		return $this;
	}

	/**
	 * @return mixed
	 */
	public function getItems() {
		return $this->items;
	}

	/**
	 * @return array
	 */
	public function getPayload()
	{
		$payload = array();
		$payload['from']['postcode'] = $this->getFromPostcode();
		$payload['from']['country'] = $this->getFromCountry();
		$payload['to']['postcode'] = $this->getToPostcode();
		$payload['to']['country'] = $this->getToCountry();
		/** @var Price_Item $item */
		foreach ($this->getItems() as $item){
			$payload['items'][] = $item->getPayLoad($this->getToCountry());
		}

		return $payload;
	}

	public function addItem( $item ) {
		$this->items[] = $item;
		return $this;
	}
}
